
CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      BLOCK DATA
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON/ ELEMENT / ELEMNT(107)
      CHARACTER*2 ELEMNT
      COMMON /MASS/ AMS1(107),AMS2(107)

      DATA ELEMNT/'h ','he',
     1 'li','be','b ','c ','n ','o ','f ','ne',
     2 'na','mg','al','si','p ','s ','cl','ar',
     3 'k ','ca','sc','ti','v ','cr','mn','fe','co','ni','cu',
     4 'zn','ga','ge','as','se','br','kr',
     5 'rb','sr','y ','zr','nb','mo','tc','ru','rh','pd','ag',
     6 'cd','in','sn','sb','te','i ','xe',
     7 'cs','ba','la','ce','pr','nd','pm','sm','eu','gd','tb','dy',
     8 'ho','er','tm','yb','lu','hf','ta','w ','re','os','ir','pt',
     9 'au','hg','tl','pb','bi','po','at','rn',
     1 'fr','ra','ac','th','pa','u ','np','pu','am','cm','bk','cf','xx',
     2 'fm','md','cb','q ',']]',']]',']]','tv'/

CICI
C     MASSES OF MOST ABUNDANT ISOTOPES (MIND: sometimes, that is only an excess
C                                             of some percent!)
C     (Handbook of Chemistry and Physics 63rd edition 1982-1983)
CICI
      DATA ams1/
     *1.007825D0,                                         4.00260D0,
C      H1                                                    He4
     *7.01600D0,9.01218D0,
C        Li7        Be9
     *11.00931D0,12.00000D0,14.00307D0,15.99491D0,18.99840D0,19.99244D0,
C         B11        C12        N14        O16        F19       Ne20
     *22.9898D0,23.98504D0,
C        Na23       Mg24
     *26.98153D0,27.97693D0,30.97376D0,31.97207D0,34.96885D0,39.948D0,
C        Al27       Si28        P31       S32        Cl35      Ar40
     *38.96371D0,39.96259D0,
C        K39        Ca40 
     *44.95592D0,   47.9D0, 50.9440D0 , 51.9405D0,
C        Sc45       Ti48        V51       Cr52
     *54.9380D0 , 55.9349D0,58.9332D0 , 57.9353D0,
C        Mn55       Fe56        Co59      Ni58
     *62.9296D0 , 63.9291D0,
C        Cu63       Zn64
     *68.9257D0,  73.9219D0,74.9216D0 , 79.9165D0, 78.9183D0, 83.9 D0,
C        Ga69       Ge74       As75       Se80       Br79       Kr84
     *84.9117D0,  87.9056D0,
C        Rb85       Sr88    
     *88.9059D0,  89.9043D0,92.9060D0 , 99.9076D0,
C        Y89        Zr90       Nb93       Mo100
     * 98.906D0 ,101.9037D0,102.9048D0,105.9032D0,
C        Tc99       Ru102      Rh103      Pd106
     *106.90509D0,113.9036D0,
C        Ag107      Cd114
     *114.9041D0, 119.9 D0 ,120.9038D0,129.9067D0,126.9044D0,131.9042D0,
C        In115      Sn120      Sb121      Te130      I127      Xe132
     *132.9051D0,137.9050D0,
C        Cs123      Ba138
     *      21*0.0D0,                  194.9648D0,
C     no data for elements 57-77         Pt195
     *196.9666D0,201.9706D0,204.9745d0,207.9766d0,208.9804d0,24*0.0d0/
c     Au197      Hg202      Tl205      Pb208      bi209       
C     no data for elements >80(Hg)



c      ghost
c      WARNING!!! these are averaged atomic masses!!!!
   
                                                                                 
      DATA  AMS2 /  1.00790D0,  4.00260D0,  6.94000D0,  9.01218D0,               
     .10.81000D0, 12.01100D0, 14.00670D0, 15.99940D0, 18.99840D0,               
     .20.17900D0, 22.98977D0, 24.30500D0, 26.98154D0, 28.08550D0,               
     .30.97376D0, 32.06000D0, 35.45300D0, 39.94800D0, 39.09830D0,               
     .40.08000D0, 44.95590D0, 47.90000D0, 50.94150D0, 51.99600D0,               
     .54.93800D0, 55.84700D0, 58.93320D0, 58.71000D0, 63.54600D0,               
     .65.38000D0, 69.73500D0, 72.59000D0, 74.92160D0, 78.96000D0,               
     .79.90400D0, 83.80000D0, 85.46780D0, 87.62000D0, 88.90590D0,               
     .91.22000D0, 92.90640D0, 95.94000D0, 98.90620D0, 101.0700D0,               
     .102.9055D0, 106.4000D0, 107.8680D0, 112.4100D0, 114.8200D0,               
     .118.6900D0, 121.7500D0, 127.6000D0, 126.9045D0, 131.3000D0,               
     .132.9054D0, 137.3300D0, 15*0.000D0, 178.4900D0, 180.9479D0,               
     .183.8500D0, 186.2070D0, 190.2000D0, 192.2200D0, 195.0900D0,               
     .196.9665D0, 200.5900D0, 204.3700D0, 207.2000D0, 208.9804D0,               
     .18*0.000D0,   1.0079D0,  5*0.000D0/                                       
c      
c
      END
