      subroutine getexdip(dip,name)
*--------------------------------------------------------------------------
* read excitation energies and transition dipole moments from file 'name'
*
* written by J. Neugebauer, Uni Erlangen, 2002
*--------------------------------------------------------------------------
      include 'defs.h'
      include 'param.h'
      integer lu,irc,ist,ien,i,rnex,j
      character*(*) name
      real*8 dip(3)
      character*128 rec
      character*128 item(mxitem)

      do i=1,3
        dip(i)=0.0d0
      end do
      lu=1
      write(iosl,*) '** getexen: trying to read ex. state dipoles from:'
      write(iosl,*) name
      call flush(iosl)
      open (UNIT=lu,FILE=name,STATUS='UNKNOWN',IOSTAT=irc)
      if (irc.NE.0) RETURN
      rnex=0
20    read (lu,'(A)',END=99) rec
      call split(rec,item,mxitem)
      IF(index(rec,'Block Davidson iteration').ne.0) then
        write(iosl,*) 'Block davidson method was used in escf'
        call flush(iosl)
        goto 70
      ELSE IF(index(rec,'MODIFIED DAVIDSON will be used').ne.0) then
        write(iosl,*) 'MODIFIED DAVIDSON was used in escf'
        call flush(iosl)
        call errex('modified davidson output not yet supported')
      END IF
      GOTO 20
70    read (lu,'(A)',END=99) rec
      IF(index(rec,'Excited state properties').eq.0) goto 70
80    read (lu,'(A)',END=99) rec
      IF(index(rec,'Electric dipole moment:').eq.0) GOTO 80
      do i=1,3
        read (lu,'(A)',END=99) rec
      end do
      read (lu,'(A)',END=99) rec
      call split(rec,item,mxitem)
      if(item(1).eq.'x') then
        read(item(4),*) dip(1)
        read (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        read(item(4),*) dip(2)
        read (lu,'(A)',END=99) rec
        CALL split(rec,item,mxitem)
        read(item(4),*) dip(3)
      end if
      GOTO 70

CC------------------------------------------------------------------
CC MODIFIED DAVIDSON output
CC------------------------------------------------------------------
C90    read (lu,'(A)',END=99) rec
C      IF(index(rec,'exc. energy (a.u./eV/cm-1/nm)').eq.0) GOTO 90
C      CALL split(rec,item,mxitem)
C      rnex=rnex+1
C      read(item(4),*) exen(rnex)
C95    read (lu,'(A)',END=99) rec
C      IF(index(rec,'transition moments').eq.0) GOTO 95
C      do i=1,6
C        read (lu,'(A)',END=99) rec
C      end do
C      CALL split(rec,item,mxitem)
C      if(item(1).eq.'m') then
C        read(item(2),*) eltdm(1,rnex)
C        read(item(3),*) eltdm(2,rnex)
C        read(item(4),*) eltdm(3,rnex)
C      end if
C      GOTO 90
 
99    CONTINUE
      CALL prmat(iosl,dip,3,rnex,'getexdip: exc. state dipole moment')
      call flush(iosl)
C      IF (rnex.NE.nexc) THEN
C       WRITE (iosl,*) ' getexen| reading from ',name
C       WRITE (iosl,*)
C     *    '        | number of excitated states expected: ',nexc
C       WRITE (iosl,*)
C     *    '        | number of excitated states expected: ',rnex
C        call flush(iosl)
C       call errex('wrong number of excited states in getexen')
C      ENDIF
      CALL flush(iosl)
      RETURN
      END
