
CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE MATOUT (A,B,ilab,NC,NR,NDIM,itext,jtext,natom)
CJN   modified by J. Neugebauer, Uni Erlangen, 2001
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'param.h'
      DIMENSION A(NDIM,NDIM), B(NDIM),ilab(*)
C**********************************************************************
C
C      MATOUT PRINTS A SQUARE MATRIX OF EIGENVECTORS AND EIGENVALUES
C
C***********************************************************************
CBAH  CHARACTER*2 ITEXT(MAXVAR), JTEXT(MAXVAR), ATORBS(3)
      CHARACTER*2 ATORBS(3),cha
      INTEGER itext(*),jtext(*),natom(*)
      COMMON/ ELEMENT / ELEMNT(107)
      CHARACTER*2 ELEMNT

      data atorbs /'X ','Y ','Z '/

      do i=1,nc
         iat=i/3
         if(mod(i,3).ne.0.or.iat.eq.0) iat=iat+1
         ixyz=(i-3*(iat-1))
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
         READ (atorbs(ixyz),'(A2)') itext(i)
         READ (ELEMNT(ilab(iat)),'(A2)') jtext(i)
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
CBAH     ITEXT(i)=ATORBS(ixyz)
CBAH     JTEXT(i)=ELEMNT(ilab(iat))
         NATOM(i)=IAT
      enddo

      KA=1
      KC=6
   60 KB=MIN0(KC,NC)
      WRITE (*,100) (I,I=KA,KB)
      IF(B(1).NE.0.D0)WRITE (*,110) (B(I),I=KA,KB)
      WRITE (*,120)
      LA=1
      LC=40
   70 LB=MIN0(LC,NR)
      DO 80 I=LA,LB
CBAH     IF(ITEXT(I).EQ.' S')WRITE(*,120)
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
         WRITE (cha,'(A2)') itext(i)
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         IF(cha.EQ.' S') WRITE(*,120)
         WRITE (*,130) ITEXT(I),JTEXT(I),NATOM(I),(A(I,J),J=KA,KB)
   80 CONTINUE
      IF (LB.EQ.NR) GO TO 90
      LA=LC+1
      LC=LC+40
      WRITE (*,140)
      GO TO 70
   90 IF (KB.EQ.NC) RETURN
      KA=KC+1
      KC=KC+6
      IF (NR.GT.25) WRITE (*,140)
      GO TO 60
C
  100 FORMAT (////,3X,9H ROOT NO.,I5,9I12)
  110 FORMAT (/8X,10F12.5)
  120 FORMAT (2H  )
  130 FORMAT (2(1X,A2),I4,F10.5,10F12.5)
  140 FORMAT (1H1)
C
      END
