CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE rcontrol(tempname,natoms,mode,inputdip,inputpol,
     .            cstep,jscfc,isuhf,iomeg,mxomeg,omeg,naus,iclean,
     .            icleanl,dalmw,idalmw,snffast,rpast,exopt,smult,idbg)
      implicit none
      real*8 xx,cstep,getreal
      integer naus,lu,mode,inputdip,inputpol,i,n,natoms,idbg,lmod
      integer rpast,exopt,iclean,icleanl
      external getreal
      character*1 tmptxt
      character*4 mform
      logical ridft,snffast
      character*(*) tempname
      character*20 a20
      INTEGER mxitem
      PARAMETER (mxitem=12)
      INTEGER jscfc,intgr,isuhf,iomeg,mxomeg,ist,ien,idalmw,smult
      character*80 dalmw
      CHARACTER*255 b1
      CHARACTER*255 item(mxitem)
      REAL*8 omeg(*)
      dimension xx(2)

      lu=1
      IF (mxitem.NE.mxomeg+2) THEN
       CALL errex('set mxitem to mxomeg+2 in rcontrol')
      ENDIF
C@    WRITE (idbg,*) 'reading <control> from ',tempname
      OPEN (UNIT=lu,FILE=tempname,STATUS='UNKNOWN')
      mode=1
      inputdip=0
      inputpol=0
      cstep=0.01
      ridft=.false.
      snffast=.false.
      iclean=0
      icleanl=0
      exopt=0
      rpast=0
      smult=1

1     READ (lu,'(A)',END=999) b1
      if(index(b1,'1st').ne.0) inputdip=1
      if(index(b1,'$exopt').ne.0) then
        read(b1(index(b1,'$exopt')+6:),*) exopt
      end if
      if(index(b1,'$soes').ne.0) then
        read (lu,'(A)',end=999) b1
        call split(b1,item,mxitem)
        read(item(2),*,err=999,end=999) rpast
      end if
      if(index(b1,'$scfinstab').ne.0) THEN
       if(index(b1,'rpas').ne.0) then
          smult=1
C         read(b1(index(b1,'rpas')+4:),*) rpast
       else if(index(b1,'ciss').ne.0) then
          smult=1
       else if(index(b1,'rpat').ne.0) then  
          smult=3
       else if(index(b1,'cist').ne.0) then  
          smult=3
       end if
       if(index(b1,'polly').ne.0) inputpol=1
       if (index(b1,'dynpol').ne.0) THEN
* read the frequencies
        CALL split(b1,item,mxitem)
        DO iomeg=3,mxitem
         IF (item(iomeg)(1:1).EQ.' ') GOTO 2
         ist=1
         omeg(iomeg-2)=getreal(item(iomeg),ist,ien)
        ENDDO
        iomeg=mxitem+1
2       iomeg=iomeg-3
        inputpol=2
********************************************
** extension for new escf version (JN)    **
**                                        **
** syntax for standard escf:              **
** $scfinstab dynpol <freq1> ... <freq10> **
**                                        **
** syntax for new escf:                   **
** $scfinstab dynpol                      **
** <freq1> ... <freq10>                   ** 
********************************************
        if(iomeg.ne.0) goto 1
200     read (lu,'(a)',end=999) b1
        if(index(b1,'$').eq.0) then
          call split(b1,item,mxitem)
          do iomeg=1,mxitem-2
            if (item(iomeg)(1:1).EQ.' ') GOTO 300
            ist=1
            omeg(iomeg)=getreal(item(iomeg),ist,ien)
          end do
          iomeg=mxitem-1
300       iomeg=iomeg-1
        end if
       end if
*      WRITE (idbg,*) 'INPUTPOL=',inputpol,' IOMEG=',iomeg
      ENDIF
      if(index(b1,'$scfconv').ne.0) THEN
       jscfc=intgr(b1(10:),i,20)
      ENDIF
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      if(index(b1,'$tmpdirclean').ne.0) iclean=1
      if(index(b1,'$logdirclean').ne.0) icleanl=1
      if(index(b1,'$ridft').ne.0) ridft=.true.
      if(index(b1,'$snffast').ne.0) snffast=.true.
      if(index(b1,'$uhf').ne.0) isuhf=1
      if(index(b1,'rimp2').ne.0) mode=3
      if(index(b1,'traloop').ne.0) mode=4
      if(index(b1,'$workescf.intel').ne.0) mode=5
      if(index(b1,'$workescf.athlon').ne.0) mode=6
      if(index(b1,'$dalmw').ne.0) then
        read(b1(8:),*) dalmw
        read(dalmw,*) idalmw
      end if
      if(index(b1,'$daltonmode').ne.0) then
        call clean(item(2))
        call split(b1,item,mxitem)
        tmptxt=' '
        mform='    '
        call llen(item(2),lmod)
        if(lmod.gt.9) stop 'error: mode too large'
        write(tmptxt,'(i1)') lmod
        mform='(i'//tmptxt//')'
        read(item(2),mform) mode
      end if
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      if(index(b1,'natoms=').ne.0) then   
       a20=b1
       call readl(20,a20,xx,n)
       natoms=int(xx(1))
      endif
      if(index(b1,'cstep').ne.0) then   
       a20=b1
       call readl(20,a20,xx,n)
       cstep=xx(1)
      endif
CJN >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      if(index(b1,'numderiv').ne.0) then   
       a20=b1
       call readl(20,a20,xx,n)
       naus=xx(1)
       naus=naus*2
      endif
      GOTO 1
999   if(natoms.lt.2) stop 'natoms < 2. stop in rcontrol'
      if(ridft) then
        if(mode.eq.5) then
          mode=7
        else if(mode.eq.6) then
          mode=8
        else
          mode=2
        end if
      end if
CJN <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      CLOSE (UNIT=lu)
      return
      end

***********************************************************************
 
      subroutine rkeyreal(anfname,anfkey,anfval)
*
* read file anfname; if <anfkey> is present, then read double precision
* variable anfval from the keyword input line
*
* written by J. Neugebauer, Uni Erlangen, 2002.
*
      implicit none
      integer lu,lanfn,lanfk
      real*8 anfval,anfold
      character*(*) anfname,anfkey
      character*132 buf
      logical ex
      lu=1
      call llen(anfname,lanfn)
      call llen(anfkey,lanfk)
      inquire(file=anfname(1:lanfn),exist=ex)
      if(.not.ex) return
      open(unit=lu,file=anfname(1:lanfn))
      anfold=anfval
10    read(lu,'(A)',end=900) buf
      if(index(buf,anfkey(1:lanfk)).ne.0) then
        read(buf(lanfk+1:),*,end=800,err=800) anfval
        goto 900
      end if
800   anfval=anfold
      goto 10
900   close(lu)
      end
 
***********************************************************************
 
      subroutine rkeyint(anfname,anfkey,anfval)
* * read file anfname; if <anfkey> is present, then read integer
* variable anfval from the keyword input line
*
* written by J. Neugebauer, Uni Erlangen, 2002.
*
      implicit none
      integer lu,lanfn,lanfk,anfval,anfvalold
      character*(*) anfname,anfkey
      character*132 buf
      logical ex
      lu=1
      anfvalold=anfval
      call llen(anfname,lanfn)
      call llen(anfkey,lanfk)
      inquire(file=anfname(1:lanfn),exist=ex)
      if(.not.ex) return
      open(unit=lu,file=anfname(1:lanfn))
10    read(lu,'(A)',end=900) buf
      if(index(buf,anfkey(1:lanfk)).ne.0) then
        read(buf(lanfk+1:),*,err=800,end=800) anfval
        goto 900
      end if
800   anfval=anfvalold
      goto 10
900   close(lu)
      end
 
***********************************************************************
 
      subroutine rkeywd(anfname,anfkey,anfval)
 
*------------------------------------------------------------------
* read file anfname; if <anfkey> is present, then set anfval=.true.
*
* written by J. Neugebauer, Uni Erlangen, 2002.
*------------------------------------------------------------------
 
      implicit none
      integer lu,lanfn,lanfk
      character*(*) anfname,anfkey
      character*132 buf
      logical ex,anfval
      lu=1
      anfval=.false.
      call llen(anfname,lanfn)
      call llen(anfkey,lanfk)
      inquire(file=anfname(1:lanfn),exist=ex)
      if(.not.ex) return
      open(unit=lu,file=anfname(1:lanfn))
10    read(lu,'(A)',end=900) buf
      if(index(buf,anfkey(1:lanfk)).ne.0) then
        anfval=.true.
        goto 900
      end if
      goto 10
900   close(lu)
      end
 
                             

