CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE rdparm
*
* read input parameters; called from imaster
*
      INCLUDE 'defs.h'
      INCLUDE 'param.h'  
      INCLUDE 'objects.h'

      CHARACTER*255 b1
      INTEGER i,intgr,ierr,l,lmy
      
* read input, unless already done so
      IF (inrec.EQ.0) CALL readin

      WRITE (*,*) 
      WRITE (*,*) '========================================='
      WRITE (*,*) '== SNFDC INPUT PARAMETERS FROM DCINPUT =='
      WRITE (*,*) '========================================='
      WRITE (*,*) 
      ierr=0
      mydir='*MYDIR?'
      CALL rdir('MYDIR',mydir,lm,0,ierr)
      WRITE (*,*) 'MYDIR        ',mydir(1:lm)

      CALL readv('TITLE',title,mydir(1:lm))
      WRITE (*,*) 'TITLE        ',title(1:60)

***   obsolete default for node-local directories on SR8000
***   CALL tmpdir(tempdir)
      tempdir=mydir
      tempdir(lm+1:lm+4)='/tmp'
      CALL rdir('TMPDIR',tempdir,lt,0,ierr)
      WRITE (*,*) 'TMPDIR       ',tempdir(1:lt)

      logdir=mydir
      logdir(lm+1:lm+4)='/log'
      CALL rdir('LOGDIR',logdir,ll,1,ierr)
      WRITE (*,*) 'LOGDIR       ',logdir(1:ll)

      CALL readv('ARPATH',arpath,' ')
      CALL llen(arpath,lar)
      IF (lar.GT.0) WRITE (*,*) 'ARPATH       ',arpath(1:lar)

      CALL readv('TURBOBIN',turbodir,' ')
      CALL llen(turbodir,lb)
      IF (lb.GT.0) WRITE (*,*) 'TURBOBIN     ',turbodir(1:lb)
      IF (lb.GT.0) THEN
       turbodir(lb+1:lb+1)='/'
       lb=lb+1
      ENDIF

      CALL readv('DCPATH',dcdir,'snfdc')
      CALL llen(dcdir,ldc)
      WRITE (*,*) 'DCPATH       ',dcdir(1:ldc)

      CALL readv('ELIGPATH',eligpath,'$CIPROC/ELIGIBLE')
      CALL llen(eligpath,lepath)
      WRITE (*,*) 'ELIGPATH     ',eligpath(1:lepath)

      icrap=0
      CALL readv('CRAP_OK',b1,'no')
      CALL llen(b1,l)
      WRITE (*,*) 'CRAP_OK      ',b1(1:l)
      IF (b1(1:6).NE.'no') icrap=1

      CALL readv('UPDATE',b1,'3')
      CALL llen(b1,l)
      updopt=intgr(b1,l,20)
C//SKIPC#14
      if(updopt.ne.3) then
        WRITE (*,*) 'UPDATE       ',b1(1:l)
        WRITE (*,*) 'virtual machine update option(s) [UPDATE] :'
        IF (MOD(updopt,2).GE.1) then
          WRITE (jtape,*) 'remove        processes on vbsy nodes'
        else
          WRITE (jtape,*) 'do not remove processes on vbsy nodes'
        end if
        IF (MOD(updopt,4).GE.2) then
          WRITE (jtape,*) 'add           processes on idle nodes'
        else
          WRITE (jtape,*) 'do not add    processes on idle nodes'
        end if
      end if
C#

      CALL readv('PREFIX',b1,'TMP%')
      CALL llen(b1,l)
      WRITE (*,*) 'PREFIX       ',b1(1:l)
      IF (l.GT.0) THEN
       logdir=logdir(1:ll)//b1(1:l)
       ll=ll+l
      ENDIF
      IF (ierr.NE.0) CALL errex('error encountered in input')

C@    CALL readv('MXSTEP',b1,'0')
C@    i=0
C@    mxstep=intgr(b1,i,20)
C@    IF (mxstep.GT.0) THEN
C@     WRITE (jtape,*) 'maximal number of steps per node :',mxstep
C@    ENDIF

      CALL readv('FSYS',b1,'0')
      CALL llen(b1,l)
      WRITE (*,*) 'FSYS         ',b1(1:l)
      i=0
      iprintf=intgr(b1,i,20)

      CALL readv('CHANNELS',b1,'0')
      CALL llen(b1,l)
      WRITE (*,*) 'CHANNELS     ',b1(1:l)
      i=0
      ierr=intgr(b1,i,20)
      IF (ierr.GT.0) CALL setmax_ctok(ierr)

      CALL clean(restart)
      restart=mydir(1:lm)//'/restart'
      dcstat =mydir(1:lm)//'/TMPdcstat'

      WRITE (*,*)
      WRITE (*,*) '========================================='
      RETURN
      END
