CC****************************************************************************** C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      SUBROUTINE tmini
*
* read control file
*
CJN   modified by J. Neugebauer, Uni Erlangen, 2001
      INCLUDE 'defs.h'
      INCLUDE 'param.h'
      INCLUDE 'objects.h'

      INTEGER i,nn,idalmw
      CHARACTER*255 b1
      character*80 dalmw
      logical snffast
      REAL*8 charge
      CHARACTER*10 calctype,prtype
      integer iclean,icleanl,mokok
      external mokok
      
* read control file

      CALL rcontrol(mydir(1:lm)//'/control',natoms,mode,inputdip,
     * inputpol,cstep,jscfc,isuhf,iomeg,mxomeg,omeg,naus,iclean,
     * icleanl,dalmw,idalmw,snffast,rpast,exopt,smult,idbg)
      ipol=0
      IF (inputpol.EQ.1) ipol=1
      IF (inputpol.EQ.2) ipol=iomeg
      okok=mokok(mode,isuhf)
cMRCK
      write(idbg,*) 'okok : ',okok
      call flush(idbg)
      if(okok.le.0) call errex('tmini | invalid okok value')
cMRCK  
      WRITE (jtape,*) 
      WRITE (jtape,'(A)') 
     *  ' ===================================================== '
      WRITE (jtape,'(A)') 
     *  ' == SNFDC INPUT PARAMETERS FROM CONTROL AND RESTART == '
      WRITE (jtape,'(A)') 
     *  ' ===================================================== '
      WRITE (jtape,*) 
C determine type of program to be used for single points and 
C type of calculation
      call prog_type(mode,prtype,calctype)
      
      WRITE (jtape,'('' number of atoms             '',i5)') natoms
      WRITE (jtape,'('' degrees of freedom (d.o.f.) '',i5)') natoms*3
      WRITE (jtape,'('' No. of steps per d.o.f.     '',i5)') naus
      WRITE (*,'('' step sizes (bohr)'',f16.5)') cstep
      WRITE (jtape,'('' program for single points   '',a10)') prtype
      WRITE (jtape,'('' type of calculations        '',a10)') calctype
      WRITE (jtape,'('' SCF convergence parameter   '',i5)') jscfc
      WRITE (jtape,'('' polarizabilities (inputpol) '',i5)') inputpol
      WRITE (jtape,'('' No. of dyn. polarizabilities '',i4)') iomeg
      IF (inputdip.EQ.0) THEN
       CALL errex('input not prepared for calculation of dipole moment')
      ENDIF
      if(snffast) then
         write(*,*) 
     *     'Omitting command <nice> for single point calculations'
      end if
      IF(iclean.eq.1) 
     *WRITE(*,'('' remove directories for single point calculations'')')
      IF(icleanl.eq.1) 
     *WRITE(*,'('' remove log files from slave processes'')')
      IF (icrap.EQ.0 .AND. jscfc.LT.iscfc) THEN
       WRITE (jtape,*)
     *  'The present parameter setting of SNFDC enforces'
       WRITE (jtape,*)
     *  'a higher accuracy for dscf/ridft than is provided'
       WRITE (jtape,*) 'in the current <control> file:'
       WRITE (jtape,*) 'SCFCONV too small on <control>'
       WRITE (jtape,*)
     *  'it is ',jscfc,', and it should be at least ',iscfc
       WRITE (jtape,*)
     *  'set "CRAP_OK yes" in the SNFDC input, if lower accuracy'
       WRITE (jtape,*)
     *  'is OK; note that this may give much less accurate results'
       WRITE (jtape,*) 'for frequency and intensities.'
       CALL errex('SCFCONV too small')
      ENDIF
      iscfc=jscfc
      IF (icrap.EQ.0 .AND. (cstep.LT.0.01.OR.cstep.GT.0.05)) THEN
       WRITE (jtape,*)
     *  'The present parameter setting of SNFDC enforces'
       WRITE (jtape,*) 'a cstep value 0.01 <= cstep <= 0.05.'
       WRITE (jtape,*) '$cstep has been given as ',cstep
       WRITE (jtape,*)
     *  'set CRAP_OK in the SNFDC input, if this is OK'
       WRITE (jtape,*)
     *  'note that this may give much less accurate results'
       WRITE (jtape,*) 'for frequency and intensities.'
       CALL errex('SCFCONV too small')
      ENDIF
      
c-----read coordinates

      CALL memmgr(memget,'ilab    ',is,plab,natoms)
      CALL memmgr(memgdw,'co      ',s8,pco,natoms*3)
      call rcoord(mydir(1:lm)//'/coord',nn,s8(pco),is(plab))

      IF (nn.NE.natoms) THEN
       WRITE (*,*) '###### natoms from control and coord differ!'
       CALL shutdown
      ENDIF

      WRITE (jtape,*) ' '
      WRITE (jtape,*)
     *  '        ORIENTATION OF MOLECULE IN FORCE CALCULATION'
      WRITE (jtape,*) ' '
      WRITE (jtape,*)
     *  '   NO.       ATOM         X         Y         Z'
      WRITE (jtape,*) ' '
      CALL wcoo(natoms,is(plab),s8(pco))

      nvar  =natoms*3
      nstept=nvar*naus

      WRITE (jtape,*)
      WRITE (jtape,'(A)') 
     *  ' ===================================================== '
      WRITE (jtape,*)
      RETURN
      END
      SUBROUTINE wcoo(natoms,ilab,co)
      INCLUDE 'defs.h'
      INTEGER natoms
      INTEGER ilab(natoms)
      REAL*8 co(3,natoms)
      INTEGER i
      DO i=1,natoms
       WRITE (*,110) i,ilab(i),
     *  co(1,i)*bohr2aa,co(2,i)*bohr2aa,co(3,i)*bohr2aa
110    FORMAT(I6,I10,4X,3F10.4)
      ENDDO
      RETURN
      END
