CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine sbox(aarg)
      character*(*) aarg
      write(*,110)
      write(*,*) aarg
      write(*,110)
110   format(70('-'))
      write(*,'(/)')
      return
      end

      subroutine header(aarg1,aarg2)
      character*(*) aarg1,aarg2

      write(*,130)
      write(*,110)
      write(*,110)
      write(*,121)aarg1
      write(*,121)aarg2
      write(*,110)
      write(*,110)
      write(*,130)
110   format(70('*'))
130   format(/)
120   format(/,20x,a,5x,i4,/)
121   format(/,20x,a,/)
 
      return
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C connect two strings                         
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      subroutine sappend(s1,s2,s3)
      character*(*) s1
      character*(*) s2
      character*(*) s3
      integer i,k 
      CALL clean(s3)
      s3=' '
      k=0
      do i=1,len(s1)
         if(s1(i:i).ne.' ') then
            k=k+1
            s3(k:k)=s1(i:i)
         endif
      enddo
      do i=1,len(s2)
         if(s2(i:i).ne.' ') then
            k=k+1
            s3(k:k)=s2(i:i)
         endif
      enddo

      return
      end
      SUBROUTINE augnum(filename,name,number)
      IMPLICIT none
      CHARACTER*(*) filename,name
      INTEGER number
      INTEGER i,j,lf,ln
      CHARACTER*10 n8
      CALL clean(filename)
      lf=LEN(filename)
      ln=LEN(name)
      IF (ln+5.GT.lf)
     *  CALL errex('augnum: buffer length too small')
      CALL clean(filename)
      filename(1:ln)=name
      WRITE (n8,'(I010)') number
      DO j=1,10
      IF (n8(j:j).NE.' ') THEN
      ln=ln+1
      filename(ln:ln)=n8(j:j)
      ENDIF
      ENDDO
      RETURN
      END
      SUBROUTINE clean(c)
      IMPLICIT none
      CHARACTER*(*) c
      INTEGER i
      DO i=1,LEN(c)
      c(i:i)=' '
      ENDDO
      RETURN
      END
      SUBROUTINE slen(c,n)
      IMPLICIT none
      CHARACTER*(*) c
      INTEGER i,l,n
      l=LEN(c)
      DO i=1,l
      IF (c(i:i).EQ.' ') THEN
       n=i-1
       RETURN
      ENDIF
      ENDDO
      n=l
      RETURN
      END
      SUBROUTINE llen(c,n)
      IMPLICIT none
      CHARACTER*(*) c
      INTEGER i,l,n
      l=LEN(c)
      DO i=l,1,-1
      IF (c(i:i).NE.' ') THEN
       n=i
       RETURN
      ENDIF
      ENDDO
      n=1
      RETURN
      END
      INTEGER FUNCTION INTGR(X,I,MX)
      CHARACTER*255 X
      CHARACTER*128 F
      DO 3 J=1,MX
      IF (X(J:J).NE.' ') GOTO 4
3     CONTINUE
      INTGR=0
      RETURN
4     CONTINUE
      DO 1 I=J,MX
      IF (X(I:I).GT.'9' .OR. X(I:I) .LT. '0') GOTO 2
1     CONTINUE
      I=21
2     I=I-J
      IF (I.EQ.0) THEN
      INTGR=0
      RETURN
      ENDIF
      WRITE (F,100) I
100   FORMAT('(I',I2,')')
      READ (X(J:20),F) K
      INTGR=K
      RETURN
      END
      SUBROUTINE SPLIT(X,ITEM,N)
      CHARACTER*(*) X
      CHARACTER*(*) ITEM(N)
      l=LEN(x)
      li=LEN(item(1))
      DO 90 I=1,N
      CALL CLEAN(ITEM(I))
90    CONTINUE
      I=0
      IT=0
1     I=I+1
      IF (I.GT.L) GOTO 999
      IF (X(I:I).NE.' ') GOTO 10
      GOTO 1
10    IT=IT+1
      IF (IT.EQ.N) THEN
      ITEM(IT)(1:li-I)=X(I:L)
      GOTO 999
      ENDIF
      J=0
11    J=J+1
      ITEM(IT)(J:J)=X(I:I)
      I=I+1
      IF (I.GT.L) GOTO 999
      IF (X(I:I).EQ.' ') THEN
      GOTO 1
      ENDIF
      GOTO 11
999   CONTINUE
      RETURN
      END

      INTEGER FUNCTION tmpxeq(cmd)
      IMPLICIT none
      INCLUDE 'param.h'
      CHARACTER*(*) cmd
      CHARACTER*255 cmdout
      INTEGER xeq
***   tmpxeq=xeq('. .profile; cd '//tempdir(1:lt)//'; '//cmd)
      CALL concat('cd ',tempdir(1:lt),cmdout)
      CALL appba(cmdout,'; ')
      CALL appba(cmdout,cmd)
      tmpxeq=xeq(cmdout)
      RETURN
      END

      INTEGER FUNCTION xeq(cmd)
      INCLUDE 'defs.h'
      CHARACTER*(*) cmd
      INTEGER i,fsystem,l
      CHARACTER*255 cbuf
      CALL clean(cbuf)
      CALL llen(cmd,l)
      cbuf(1:l)=cmd
      i=fsystem(l,cbuf)
      WRITE (iosl,*) 'xeq[',i,'] ',cmd
      CALL flush(iosl)
      xeq=i
C+    xeq=0
      RETURN
      END
      SUBROUTINE tosec(item,sec)
      IMPLICIT none
      CHARACTER*255 item(12)
      REAL*8 sec
      REAL*8 rr
      INTEGER i,intgr
      sec=0.D0
      IF (item(5).EQ.'seconds') THEN
       READ (item(4),'(D20.10)') sec
       RETURN
      ENDIF
      IF (item(5).EQ.'minutes') THEN
       i=1
       rr=DFLOAT(intgr(item(4),i,20))
       sec=sec+rr*60.
       i=1
       rr=DFLOAT(intgr(item(7),i,20))
       sec=sec+rr
       RETURN
      ENDIF
      IF (item(5).EQ.'hours') THEN
       i=1
       rr=DFLOAT(intgr(item(4),i,20))
       sec=sec+rr*3600.
       i=1
       rr=DFLOAT(intgr(item(6),i,20))
       sec=sec+rr*60.
       i=1
       rr=DFLOAT(intgr(item(9),i,20))
       sec=sec+rr
       RETURN
      ENDIF
      IF (item(5).EQ.'days') THEN
       i=1
       rr=DFLOAT(intgr(item(4),i,20))
       sec=sec+rr*86400.
       i=1
       rr=DFLOAT(intgr(item(6),i,20))
       sec=sec+rr*3600.
       i=1
       rr=DFLOAT(intgr(item(8),i,20))
       sec=sec+rr*60.
       i=1
       rr=DFLOAT(intgr(item(11),i,20))
       sec=sec+rr
       RETURN
      ENDIF
      RETURN
      END

      subroutine prog_type(mode,prtype,catype)
C
C returns type of program to be used for single points and
C type of calculation to be done for a given input value <mode>.
C if <mode> is unknown, the program will terminate.
C
C written by J. Neugebauer, Uni Erlangen, 2002.
C
 
      implicit none
      integer maxmod,mode
      parameter(maxmod=30)
      character*10 prtype,catype,progtype(maxmod),calctype(maxmod)
      data progtype /
     & 'TURBOMOLE ','TURBOMOLE ','TURBOMOLE ','TURBOMOLE ','TURBOMOLE ',
     & 'TURBOMOLE ','TURBOMOLE ','TURBOMOLE ','          ','          ',
     & '          ','          ','          ','          ','          ',
     & '          ','          ','          ','          ','DALTON    ',
     & 'DALTON    ','DALTON    ','DALTON    ','DALTON    ','DALTON    ',
     & 'DALTON    ','DALTON    ','          ','          ','          '/
      data calctype /
     & 'DSCF      ','RIDFT     ','RIMP2     ','MPGRAD    ','DSCF/ESCFI',
     & 'DSCF/ESCFA','RI/ESCFI  ','RI/ESCFA  ','          ','          ',
     & '          ','          ','          ','          ','          ',
     & '          ','          ','          ','          ','SCF       ',
     & 'MP2       ','CC2       ','CCS       ','CCSD      ','MCSCF     ',
     & 'SCF/TDHF  ','MP2/SOPPA ','          ','          ','          '/
      if(mode.ge.1.and.mode.le.maxmod) then
        prtype=progtype(mode)
        catype=calctype(mode)
      else
        write(*,'(a)') '** progtype: unknown program type'
        stop
      end if
      if(prtype.eq.'          '.or.catype.eq.'          ') then
        write(*,'(a)') '** progtype: unknown program type'
        call errex('unknown program type')
      end if
      end

      integer function mokok(mode,isuhf)
C
C returns the value okok for the given input value of mode
C (okok is the number of files to be copied to the slaves,
C written as a binary number)
C
      implicit none
      integer maxmod,mode,isuhf
      parameter(maxmod=30)
      integer okok(maxmod)
      data okok /
     *   1111, 11111, 11111,  1111,  1111,
     *   1111, 11111, 11111,     0,     0,
     *      0,     0,     0,     0,     0,
     *      0,     0,     0,     0,  1111,
     *   1111,  1111,  1111,  1111,  1111,
     *   1111, 11111,     0,     0,     0 /

      if(mode.ge.1.and.mode.le.maxmod) then
        mokok=okok(mode)
      else
        mokok=0
        return
      end if
      if(mokok.eq.0) return
      if(isuhf.gt.0) mokok=mokok*10+1
      end 

      subroutine ptime(sec,tbuf)
*
*     formatted output of time sec (in seconds)
*     in days, hours, minutes, and seconds
*
*     written by J. Neugebauer, Uni Erlangen, 2002
*
      implicit none
      integer y,sec,h,m,s,d,osec,unit,w
      character*132 tbuf
      call sec2hms(sec,y,w,d,h,m,s)
      if(y.gt.0) then
        write(tbuf,101) y,' years ',w,' weeks ',d,' days ',h,
     *  ' hours ',m,' minutes ',s,' seconds'
      else if(w.gt.0) then
        write(tbuf,100) w,' weeks ',d,' days ',h,' hours ',
     *   m,' minutes ',s,' seconds'
      else if(d.gt.0) then
        write(tbuf,100) d,' days ',h,' hours ',m,' minutes ',
     *   s,' seconds'
      else if(h.gt.0) then
        write(tbuf,100) h,' hours ',m,' minutes ',s,' seconds'
      else if(m.gt.0) then
        write(tbuf,100) m,' minutes ',s,' seconds'
      else
        write(tbuf,100) s,' seconds'
      end if
100   format(i2,5(a,i2))
101   format(i6,6(a,i2))
      end
 
      subroutine sec2hms(seci,y,w,d,h,m,s)
*
*     input : time in seconds
*     output: time in weeks, days, hours, minutes, seconds
*     (echter Sonnenumlauf: 365.242199 Tage)
*
*     1 year     = 31556952  seconds (Gregorianischer Kalender, 365.2425 days)
*     1 week     =   604800  seconds
*     1 day      =    86400  seconds
*     1 hour     =     3600  seconds
*     1 minute   =       60  seconds
*
*     written by J. Neugebauer, Uni Erlangen, 2002
*
      implicit none
      integer seci,h,m,s,d,osec,w,y
 
      osec=seci
      y=seci/31556952
      seci=seci-y*31556952
      w=seci/604800
      seci=seci-w*604800
      d=seci/86400
      seci=seci-d*86400
      h=seci/3600
      seci=seci-h*3600
      m=seci/60
      seci=seci-m*60
      s=seci
      seci=osec
      end
  

      SUBROUTINE snfdchead
      IMPLICIT none
      write(*,'(A)')
C                     +1234567890123456789012345678+8765432109876543210987654321+
      write(*,'(A)')' +---------------------------------------------------------+'
      write(*,'(A)')' |                                                         |'
      write(*,'(A)')' |                        S N F D C                        |'
      write(*,'(A)')' |                                                         |'
      write(*,'(A)')' |    B. A. Hess, J. Neugebauer, M. Reiher, C. Kind        |'
      write(*,'(A)')' |                                                         |'
      write(*,'(A)')' |  Universitaet Erlangen, Egerlandstr. 3, 91058 Erlangen  |'
      write(*,'(A)')' |                        1999-2001                        |'
      write(*,'(A)')' |                                                         |'
      write(*,'(A)')' +---------------------------------------------------------+'
C                     +1234567890123456789012345678+8765432109876543210987654321+
      write(*,'(A)')
      RETURN
      END
