CC******************************************************************************
C   Copyright 1999 -- 2002 C. Kind, M. Reiher, J. Neugebauer, and B. A. Hess,
C   Chair of Theoretical Chemistry, Friedrich-Alexander-University 
C   Erlangen-Nuremberg, Egerlandstr. 3, D-91058 Erlangen, Germany.
C
C
C   This file is part of the package SNF.
C
C   SNF is free software; you can redistribute it and/or modify
C   it under the terms of the GNU General Public License as published by
C   the Free Software Foundation; either version 2 of the License, or
C   (at your option) any later version.
C
C   This program is distributed in the hope that it will be useful,
C   but WITHOUT ANY WARRANTY; without even the implied warranty of
C   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C   GNU General Public License for more details.
C
C   You should have received a copy of the GNU General Public License
C   along with this program; if not, write to the Free Software
C   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
CC******************************************************************************
      subroutine wdal(tdr,jstepa,natoms,ic,co)
  
*     write DALTON input file molecule.mol
*     note: "based" is no longer used
*
*     written by J. Neugebauer, Uni Erlangen, 2002

      include 'defs.h'
      integer info, system,ounit,ltd,jstepa,natoms,ldmn,ic(natoms)
      character*(*) tdr
      character*255 tmpc,fname
      character*24 dmname
      real*8 co(3,natoms)
      parameter(ounit=1)
      logical ex,udalinp
* variables for basis set
      integer mxatt,mxl,mxc,mxp,lf
      parameter(mxatt=20,mxl=7,mxc=20,mxp=30)
      integer natt,nlqz(mxatt),ncon(mxl,mxatt),nprim(mxc,mxl,mxatt)
      integer ibc(mxatt),lqn(mxl,mxatt)
      real*8 coef(mxp,mxc,mxl,mxatt),expo(mxp,mxc,mxl,mxatt)

 
      call llen(tdr,ltd)
      call clean(fname)
      fname=tdr(1:ltd)//'/control'
      call llen(fname,lf)
      call rkeywd(fname(1:lf),'$usedaltoninput',udalinp)

      call clean(fname)
      fname=tdr(1:ltd)//'/molecule.mol'
      call rmfile(fname,1)

      if(udalinp) then
        write(idbg,*) '** wdal | calling moddalmol ...'
        call flush(idbg)
        call moddalmol(tdr,natoms,ic,co,idbg)
        write(idbg,*) '** wdal | back from moddalmol ...'
        call flush(idbg)
        fname=tdr(1:ltd)//'/basedscript.tmp'
        call rmfile(fname,1)
        goto 100
      end if
*      inquire(file='mos',exist=ex)
*      if(ex) then
*        call rmfile('mos.tmp',1)
*        info=system('mv mos mos.tmp')
*        if(info.ne.0) goto 900
*      end if
      call clean(fname)
      fname=tdr(1:ltd)//'/molecule.MOPUN'
      call rmfile(fname,1)
      call clean(fname)
      fname=tdr(1:ltd)//'/molecule.dalton'
      call rmfile(fname,1)
      call clean(fname)
      fname=tdr(1:ltd)//'/basedscript.tmp'
      call rmfile(fname,1)
      write(iosl,*) 'wdal: calling rbas'
      call rbas(mxatt,mxl,mxc,mxp,natt,nlqz,ncon,nprim,coef,expo,tdr,
     * ibc,lqn)
      call wdalton(tdr,natoms,co,ic,mxatt,mxl,mxc,mxp,natt,nlqz,ncon,
     * nprim,coef,expo,jstepa,ibc)

100   open(unit=ounit,file=fname)
C       call clean(tmpc)
C       tmpc='cd '//tdr(1:ltd)
C       write(ounit,'(a)') tmpc
C       write(ounit,'(a)') 'based << !'
CC       write(ounit,'(a)') 'bbased << !'
C       call clean(tmpc)
C       tmpc='re '//tdr(1:ltd)//'/control'
C       write(ounit,'(a)') tmpc
C       write(ounit,'(a)') 
C       tmpc='wr '//tdr(1:ltd)//'/molecule.dalton'
C       write(ounit,'(a)') tmpc
C       write(ounit,'(a)') 'x'
C       write(ounit,'(a)') '!'
      call clean(tmpc)
      call augnum(dmname,'molecule',jstepa)
      call llen(dmname,ldmn)
C       tmpc='mv '//tdr(1:ltd)//'/molecule.dalton '
C     * //tdr(1:ltd)//'/'//dmname(1:ldmn)//'.mol'
C       write(ounit,'(a)') tmpc
      call clean(tmpc)
      tmpc='cp '//tdr(1:ltd)//'/molecule.dal '
     *//tdr(1:ltd)//'/'//dmname(1:ldmn)//'.dal'
      write(ounit,'(a)') tmpc
      if(udalinp) then
        call clean(tmpc)
        tmpc='cp '//tdr(1:ltd)//'/molecule.mol '
     *  //tdr(1:ltd)//'/'//dmname(1:ldmn)//'.mol'
        write(ounit,'(a)') tmpc
      end if
      close(ounit)
      call exscript(fname,info)
*      if(ex) then
*        info=system('mv mos.tmp mos')
*        if(info.ne.0) goto 900
*      end if
      call clean(tmpc)
CC      write(tmpc,'(a)') tdr(1:ltd)//'/'//dmname(1:ldmn)//'.mol'
C      tmpc=tdr(1:ltd)//'/'//dmname(1:ldmn)//'.mol'
C      inquire(file=tmpc, exist=ex)
C      write(iosl,*) 'wdal: checking for based output file: '
C      write(iosl,*) tmpc(1:80)
C      write(iosl,*) 'ex: ',ex          
C      call flush(iosl)
C      if(info.ne.0.or.(.not.ex)) then
C        call clean(tmpc)
C        tmpc='cp '//tdr(1:ltd)//'/'//dmname(1:ldmn)//'.mol.test '
C     *  //tdr(1:ltd)//'/'//dmname(1:ldmn)//'.mol'
C        write(iosl,*) 'wdal: trying to copy test input file: '
C        write(iosl,*) tmpc(1:120)
C        info=system(tmpc)
C        if(info.ne.0) then
C          write(iosl,*) 'wdal: no chance to create DALTON input.'
C          call flush(iosl)
C          call errex('no chance to create DALTON input')
C        end if
C      end if
      write(iosl,*) 'exit from wdal'
      return
900   write(iosl,*) '** wdal: error while creating molecule.mol'
      stop
      end

*************************************************************************
 
      subroutine exscript(rfile,info)
*
*     make script rfile executable and execute it.
*
*     written by J. Neugebauer, University of Erlangen, 2001
 
      include 'defs.h'
      character*(*) rfile
      character*255 tmpchar
      integer info,system,lrfile
      logical ex
 
      call llen(rfile,lrfile)
      call clean(tmpchar)
      tmpchar='chmod u+x '//rfile(1:lrfile)
      info=system(tmpchar)
      if(info.ne.0) goto 900
      write(iosl,'(2a)') '** exscript: executing ',rfile(1:lrfile)
      write(*,'(72(''*''))')
      info=system(rfile(1:lrfile))
      if(info.ne.0) goto 900
      write(iosl,'(72(''*''))')
      return
900   write(iosl,'(2a)') '** exscript: could not execute ',
     *rfile(1:lrfile)
C      stop
      end
 
C************************************************************************
 
      subroutine rmfile(rfile,mode)
*
*     if rfile exists, then remove it. if mode = 1, move file to file.bak
*
*     written by J. Neugebauer, University of Erlangen, 2001
 
      include 'defs.h'
      character*(*) rfile
      character*255 tmpchar,tmptxt
      integer mode,info,system,lrfile,ltxt
      logical ex
 
      call llen(rfile,lrfile)
      inquire(file=rfile(1:lrfile),exist=ex)
      call clean(tmpchar)
      if(ex) then
        if(mode.eq.1) then
          call clean(tmptxt)
          tmptxt=rfile(1:lrfile)//' to '//rfile(1:lrfile)//'.bak'
          call llen(tmptxt,ltxt)
          write(iosl,'(2a)') '** rmfile: moving file ',tmptxt(1:ltxt)
          tmpchar='mv '//rfile(1:lrfile)//' '//rfile(1:lrfile)//'.bak'
          info=system(tmpchar)
        else
         write(iosl,'(2a)') '** rmfile: removing file ',rfile(1:lrfile)
         tmpchar='rm '//rfile(1:lrfile)
         info=system(tmpchar)
        end if
        if(info.ne.0) then
         write(iosl,'(2a)') '** Error while (re)moving ',rfile(1:lrfile)
        end if
      end if
      end

 
C************************************************************************
 

      subroutine wdalton(tdr,natoms,co,ic,mxatt,mxl,mxc,mxp,natt,nlqz,
     * ncon,nprim,coef,expo,jstepa,ibc)
*
* write DALTON input file "molecule.mol" to avoid based call
* 
* written by J. Neugebauer, Uni Erlangen, 2002
*
      include 'defs.h'
      integer natoms,i,j,ih,ltd,ic(natoms),kcharge,ntyp,iat,mxsh
      parameter(mxsh=1500)
      integer lam,nco(mxsh),ldmn,jstepa,lf2
      real*8 co(3,natoms)
      character*(*) tdr
      character*24 dmname
      character*255 fname,fname2
      character*2 symtxt
      character*1 charm
      parameter(ih=1)
* variables for basis set
      integer mxatt,mxl,mxc,mxp,ibc(mxatt)
      integer natt,nlqz(mxatt),ncon(mxl,mxatt),nprim(mxc,mxl,mxatt)
      real*8 coef(mxp,mxc,mxl,mxatt),expo(mxp,mxc,mxl,mxatt)

      call clean(fname)
      call llen(tdr,ltd)
      call clean(dmname)
      call augnum(dmname,'molecule',jstepa)
      call llen(dmname,ldmn)
      fname=tdr(1:ltd)//'/'//dmname(1:ldmn)//'.mol'
      open(unit=ih,file=fname)
      WRITE (IH,'(A)') 'INTGRL'
      WRITE (IH,'(A)') 'DALTON input converted from TURBOMOLE'
      WRITE (IH,'(A)') '====================================='
      call flush(ih)
      kcharge=0
      call clean(fname2)
      fname2=tdr(1:ltd)//'/control'
      call llen(fname2,lf2)
      call molchar(fname2(1:lf2),natoms,ic,kcharge)
***
* determine number of different atom types
***
      ntyp=1
      do 75 j=2,natoms
        do i=1,j-1
          if(ic(i).eq.ic(j)) goto 75
        end do
        ntyp=ntyp+1
75    continue
      symtxt=' 0'
      charm=' '
      WRITE (IH,8800) charm,ntyp,kcharge,symtxt
8800  FORMAT(A1,I4,I3,A2)
      ntyp=0
      do 71 iat=1,natoms
        do i=1,iat-1
          if(ic(iat).eq.ic(i)) goto 71
        end do
        do i=1,mxatt
          if(ic(iat).eq.ibc(i)) ntyp=i
        end do
        lam=nlqz(ntyp)
        do i=1,lam
          nco(i)=1
        end do
        call wdalgeo(ih,iat,lam,nco,symtxt,ic,natoms,co)
        call wrgcdal(ih,ntyp,lam,mxatt,mxl,mxc,mxp,ncon,nprim,coef,expo)
71    continue
      close(ih)
      end                      



 
C************************************************************************

      SUBROUTINE wdalgeo(ih,iat,lam,nco,stxt,ic,natoms,co)
*
* write geometry record
*
CJN
* modified wmolgeo routine, taken from based (by B.A. Hess)
* modifications by J. Neugebauer, University of Erlangen, 2002
CJN
      INCLUDE 'defs.h'
      integer natoms
      INTEGER ih,iat,lam,nco(lam),ic(natoms)
      real*8 co(3,natoms)
      character*2 find_element
      external find_element
* local
      CHARACTER*1 kaset
      CHARACTER*6 atn,aname
      CHARACTER*2 stxt
      INTEGER irc,nont,i,j,k
 
      kaset=' '
 
* determine number of centres with equal nuclear charge number
      nont=0
      DO j=1,natoms
        IF(ic(j).eq.ic(iat)) nont=nont+1
      END DO
      WRITE (ih,11) kaset,dble(ic(iat)),nont,lam,(nco(j),j=1,lam)
11    FORMAT (A1,F9.0,12I5)
 
* this atom
      WRITE (ih,12) find_element(ic(iat)),(co(j,iat),j=1,3)
* the other atoms of this type
      DO k=iat+1,natoms
       IF(ic(iat).eq.ic(k)) then
        WRITE (ih,12) find_element(ic(iat)),(co(j,k),j=1,3)
       END IF
      ENDDO
12    FORMAT (A2,2X,3F20.15)
      RETURN
      END
 
 
C************************************************************************
 

      subroutine molchar(fname,natoms,ic,mcharge)
*
* calculate molecular charge from occupation numbers in control
* 
* written by J. Neugebauer, Uni Erlangen, 2002
*
      include 'defs.h'
      integer mxsh,natoms,nmo,nel,ic(natoms),mcharge,lfn
      integer i,ih2
      parameter(ih2=2,mxsh=1500)
      integer nocc(mxsh)
      integer elec
      character*4 irrep(mxsh)
      character*132 buf
      character*(*) fname
      nmo=0
      mcharge=0
      do i=1,natoms
        mcharge=mcharge+ic(i)
      end do
      nel=0
      call llen(fname,lfn)
      write(iosl,*) 'fname: ',fname(1:lfn)
      call flush(idbg)
      open(unit=ih2,file=fname(1:lfn))
1     continue
      read(ih2,'(A)',end=999) buf
9     continue
      elec=0
      IF (buf(1:15).EQ.'$closed shells ') elec=2
      IF (buf(1:13).EQ.'$open shells ') elec=1
      IF (buf(1:14).EQ.'$alpha shells ') elec=1
      IF (buf(1:13).EQ.'$beta shells ') elec=1
      if(elec.le.0) goto 1
      call gotm21(ih2,irrep,nmo,nocc,mxsh,buf)
      do i=1,nmo
        call upper(irrep(i))
        if(index(irrep(i),'E').ne.0) then
          nel=nel+2*int(elec*nocc(i)+.5d0)
        else if(index(irrep(i),'A').ne.0) then
          nel=nel+int(elec*nocc(i)+.5d0)
        else if(index(irrep(i),'B').ne.0) then
          nel=nel+int(elec*nocc(i)+.5d0)
        else if(index(irrep(i),'T').ne.0) then
          nel=nel+3*int(elec*nocc(i)+.5d0)
        else if(index(irrep(i),'F').ne.0) then
          nel=nel+4*int(elec*nocc(i)+.5d0)
        else if(index(irrep(i),'H').ne.0) then
          nel=nel+5*int(elec*nocc(i)+.5d0)
        else if(index(irrep(i),'G').ne.0) then
          nel=nel+4*int(elec*nocc(i)+.5d0)
        end if
      end do
      goto 9
999   close(ih2)
      write(iosl,*) 'molchar | nuclear charge = ',mcharge,
     * ', no. el. = ',nel
      write(iosl,*) 'molchar | molecular charge = ',mcharge-nel
      mcharge=mcharge-nel
      call flush(idbg)
      end

 
C************************************************************************

      subroutine gotm21(ir,irrep,nmo,nocc,mxsh,buf)
*
* find number and irrep of occupied orbitals in control file
* 
* written by J. Neugebauer, Uni Erlangen, 2002
* based on the corresponding subroutine in program "based" by B.A. Hess
*
      include 'defs.h'
      integer mxsh,nmo,ir,mxitem,i,ist,ien,intgr
      integer nocc(mxsh)
      parameter(mxitem=4)
      character*80 item(mxitem)
      character*132 buf
      character*4 irrep(mxsh)
      external intgr
      nmo=0
1     READ (ir,'(A)',END=999) buf
      CALL split(buf,item,mxitem)
      IF (item(1)(1:1).EQ.'$') GOTO 999
      nmo=nmo+1
* find irrep
      read(item(1),'(A4)') irrep(nmo)
* find single number or range
      ist=intgr(item(2),i,30)
      ien=ist
      i=i+1
      if(item(2)(i:i).eq.'-') then
        ien=intgr(item(2)(i+1:30),i,30)
      end if
      nocc(nmo)=ien-ist+1
      write(idbg,*) ' gotm21 | irrep ',item(1)(1:4),'nocc=',nocc(nmo)
      goto 1
999   continue
      end

 
C************************************************************************

      subroutine wrgcdal(ih,iat,lam,mxatt,mxl,mxc,mxp,
     * ncon,nprim,gcoef,gexpo)
*
* write generalized contraction (basis in DALTON format)
*
* based on a subroutine from program "based" by B. A. Hess.
*
* written by J. Neugebauer, University of Erlangen, 2002
*  

      include 'defs.h' 
* variables for basis set
      integer mxatt,mxl,mxc,mxp
      integer ncon(mxl,mxatt),nprim(mxc,mxl,mxatt),lerr
      real*8 gcoef(mxp,mxc,mxl,mxatt),gexpo(mxp,mxc,mxl,mxatt)

      integer i,j,maxexp,maxcon,ip,iat,ih,lam,k,l
      parameter(maxexp=200,maxcon=40)
      real*8 coef(maxexp,maxcon),expo(maxexp)
      character*80 errmsg

      do i=1,lam
        do j=1,maxexp
          do k=1,maxcon
            coef(j,k)=0.0d0
          end do
          expo(j)=0.0d0
        end do
        ip=0
        do j=1,ncon(i,iat)
          do k=1,nprim(j,i,iat)
            do l=1,ip
              if(abs(gexpo(k,j,i,iat)-expo(l)).lt.1.0d-8) then
                coef(l,j)=gcoef(k,j,i,iat)
                goto 90
              end if
            end do
            ip=ip+1
            expo(ip)=gexpo(k,j,i,iat)
            coef(ip,j)=gcoef(k,j,i,iat)
90          continue
          end do
        end do
        call wrexbdal(ih,ip,ncon(i,iat),maxexp,maxcon,coef,expo)
      end do 
      end

C************************************************************************
 
        subroutine wrexbdal(ih,ip,ic,maxexp,maxcon,co,ex)
C
C write single gen. contracted basis function
C
C based on a subroutine from program "based" by B. A. Hess.
C written by J. Neugebauer, University of Erlangen, 2002
C
        implicit none
        integer ih,ip,ic,maxexp,maxcon,j,k
        real*8 co(maxexp,maxcon),ex(maxexp)
        character(len=72) coform
 
        write(ih,'(a1,i4,i5)') 'H',ip,ic
        do k=1,ip
          if(ic.le.3) then
            coform='(4f20.10)'
          else
            coform='(4f20.10/,(20x,3f20.10))'
          end if
          write(ih,coform) ex(k),(co(k,j),j=1,ic)
        end do
        end

C************************************************************************
 
      subroutine moddalmol(tdr,nnatoms,ic,co,idbg)
C
C write new set of coordinates to DALTON molecule.mol file.
C
C written by J. Neugebauer, Uni Erlangen, 2002
C
      implicit none
      integer nnatoms,ltd,ic(nnatoms),ir1,lo,lr,lend,iat,idbg
      character*(*) tdr
      character*(255) fname
      real*8 co(3,nnatoms)
      logical basis,atomba,intgrl

      integer kcharg,nat,i,natoms,nsh,nsaos,nnsh,nont,nnsaos
      integer mxat,mxsh
      parameter(mxat=1000,mxsh=50)
      integer lam(mxat),nco(mxsh,mxat)
      CHARACTER*1 charm,id3
      CHARACTER*2 symtxt
      CHARACTER*72 coform
      CHARACTER*132 buf           

      ir1=1
      lo=2
      
      call llen(tdr,ltd)
      call clean(fname)
      fname=tdr(1:ltd)//'/molecule.mol.ori'
      open(unit=ir1,file=fname)
      call clean(fname)
      fname=tdr(1:ltd)//'/molecule.mol'
      open(unit=lo,file=fname)
******
* Card 1: INTGRL, BASIS, or ATOMBASIS
******
      read (ir1,'(a)',ERR=900,END=900) buf
      write(idbg,*) 'Card 1:'
      write(idbg,*) buf(1:70)
      call flush(idbg)
      lend=2
      IF(buf(1:5).EQ.'BASIS') THEN
        basis=.true.
        lend=3
      ELSE IF (buf(1:6).eq.'ATOMBA') THEN
        atomba=.true.
      ELSE IF (buf(1:6).eq.'INTGRL') THEN
        intgrl=.true.
      ELSE
        call errex('Error! Found wrong keyword: '//buf(1:6))
      END IF                                  
      call llen(buf,lr)
      write(lo,'(a)') buf(1:lr)
      call flush(lo)
******
* Card 2,3: (basis,) title
******          
      do i=1,lend
        read (ir1,'(a)',ERR=900,END=900) buf
        call llen(buf,lr)
        write(lo,'(a)') buf(1:lr)
        call flush(lo)
      end do
******
* Card 4:
******
      READ (ir1,'(a)',ERR=900,END=900) buf
      READ (buf,'(BN,A1,I4,I3,A2,10A1)')
     &    charm,nat,kcharg,symtxt,(id3,i=1,10)
      if(symtxt.ne.' 0'.and.symtxt.ne.'0 ') then
        call errex('Displaced geometries must be calculated in C1 !')
      end if
      call llen(buf,lr)
      write(lo,'(a)') buf(1:lr)
      call flush(lo)

******
* geometry records
******
      natoms=0
      nsaos=0
      nsh=0
      DO iat=1,nat
        CALL rwdalgeo(lo,ir1,1+natoms,lam(iat),nco(1,iat),symtxt,nont,
     *    mxsh,co,nnatoms,atomba,basis)
        natoms=natoms+nont
        nnsaos=0
        nnsh=0
        CALL rwgtodal(lo,ir1,lam(iat),nco(1,iat),nnsaos,nnsh,mxsh)
        nsh=nsh+nnsh*nont
        nsaos=nsaos+nnsaos*nont
      END DO              
      

900   close(ir1)
      close(lo)
      end


      SUBROUTINE rwdalgeo(lo,ir1,iat,lam,nco,stxt,nont,mxsh,co,natoms,
     * atomba,basis)
*
* read/write geometry record for one block
*
* written by J. Neugebauer 10/2001
*
      INCLUDE 'defs.h'
      INTEGER ir1,iat,lam,mxsh,nco(mxsh),nat,lo,natoms
      real*8 co(3,natoms),zs
* local
      CHARACTER*1 zset
      CHARACTER*4 atn
      CHARACTER*2 stxt
      CHARACTER*40 atbstring
      CHARACTER*132 buf
      INTEGER irc,nont,i,j,k,nu
      LOGICAL zmattst,atomba,basis
 
      zmattst=.false.
      IF(stxt.ne.' 0'.and.stxt.ne.'  '.and.stxt.ne.'0 ') THEN
        call errex('Symmetry adapted input not yet possible')
      END IF
 
* read data for all blocks
 
******
* Card 6: ATOMIC DATA:
*         zs(i) - nuclear charge
*         nont  - number of symmetry independent atoms
*         lam   - maximum angular quantum number (s=1,p=2,d=3 etc.)
*         nco   - number of AO-blocks for each l-value
******
      if(atomba.or.basis) then
        read (ir1,12,ERR=999,END=999)
     *   zset,zs,nont,atbstring
        write (lo,12) zset,zs,nont,atbstring
        call flush(lo)
      else
        read (ir1,11,ERR=999,END=999)
     *   zset,zs,nont,lam,(nco(j),j=1,lam)
        write (lo,11) zset,zs,nont,lam,(nco(j),j=1,lam)
        call flush(lo)
      end if
11    FORMAT (A1,F9.0,12I5)
12    FORMAT (A1,F9.0,I5,A)
      IF(zset.ne.' ') THEN
        zmattst=.true.
        call errex('Z-matrix input not yet implemented')
      END IF
 
******
* Card 7: atomic name and coordinates
*           atn - name of symmetry independent center
*           coo - coordinates of symmetry independent center
******
 
* this atom and the symmetry-equivalent atoms
      DO k=iat,iat+nont-1
        READ (ir1,'(A)',ERR=999,END=999) buf
        READ (buf,'(a4)',ERR=999,END=999) atn
        write (lo,'(a4,3f20.12)') atn,(co(j,k),j=1,3)
        call flush(lo)
      END DO
      RETURN
999   call errex('Error while reading molecular structure input')
      END           


*************************************************************************

      SUBROUTINE rwgtodal(lo,ir1,lam,nco,nsaos,nsh,mxsh)

      INCLUDE 'defs.h'
      INTEGER ir1,psy,nuc,nrc,lam,nsaos,lr
      integer mxsh,lo
      CHARACTER*72 coform
      CHARACTER*132 buf
      CHARACTER*1 frmt
      INTEGER i,j,k,ncol,l,m,nco(mxsh),nsh,pb
      LOGICAL free
 
      nsaos=0
      nsh=0
      DO 200 i = 1,lam
       DO 250 j = 1,nco(i)
******
* Card 8:
*
* nuc - number of uncontracted shells in AO-block
* nrc - number of contracted shells in AO-block
******
        READ (ir1,'(a)',ERR=900,END=900) buf
        call llen(buf,lr)
        write (lo,'(a)') buf(1:lr)
        call flush(lo)
        READ (buf,'(BN,A1,I4,I5)') frmt,nuc,nrc
* i=l - 1
        nsaos=nsaos+nrc*(2*i-1)
        nsh=nsh+nrc
        IF (frmt .EQ. 'F' .OR. frmt .EQ. 'f') THEN      
           free = .TRUE.
        ELSE IF (frmt .EQ. 'H' .OR. frmt .EQ. 'h') THEN
           free = .FALSE.
           ncol = 4
        ELSE
           free = .FALSE.
           ncol = 8
        END IF
        IF(nrc.NE.0) THEN
          DO 100 l=1,nuc
******
* Card 9:
******
            READ(ir1,'(a)',ERR=900,END=900) buf
            call llen(buf,lr)
            write (lo,'(a)') buf(1:lr)
            call flush(lo)
            IF(free) THEN
              call errex('free format not yet supported')
            ELSE
              DO 300 k=2,(nrc-1)/(ncol-1)+1
                READ(ir1,'(a)',ERR=900,END=900) buf
                call llen(buf,lr)
                write (lo,'(a)') buf(1:lr)
                call flush(lo)
300           CONTINUE
            END IF
100       CONTINUE
        ELSE
          call errex('No coefficients available')
        END IF
250    CONTINUE
200   CONTINUE
 
900   RETURN
      END                         

